import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.sql.*;
import java.util.*;

/**
  *
  * Fr den Zugriff auf eine Datenbank mssen Sie eine ODBC-Datenquelle
  * in der Windows-Systemsteuerung einrichten.
  * Start/Systemsteuerung/System&Sicherheit/Verwaltung/Datenquellen
  *
  * @version 1.0 vom 08.06.2010
  * @author
  */

public class SQLExplorer extends JFrame {
  // Anfang Attribute
  private JLabel jLDatenbank = new JLabel();
  private JTextField jtfDatenbank = new JTextField();
  private JLabel jLSQL = new JLabel();
  private JTextArea jtaSQLAnweisung = new JTextArea("");
    private JScrollPane jtaSQLAnweisungScrollPane = new JScrollPane(jtaSQLAnweisung);
  private JButton jBLoeschen = new JButton();
  private JButton jBSelect = new JButton();
  private JButton jBDMLDDL = new JButton();
  private JTable jtaTabelle = new JTable(1, 1);
    private JScrollPane jtaTabelleScrollPane = new JScrollPane(jtaTabelle);
  private JLabel jlDatensaetze = new JLabel();
  
  Connection DBVerbindung;  // Verbindung zur Datenbank
  Statement SQLAnweisung;   // SQL-SELECT-Anweisung
  // Ende Attribute

  public SQLExplorer(String title) {
    // Frame-Init
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 484;
    int frameHeight = 446;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);
    setResizable(false);
    // Anfang Komponenten

    jLDatenbank.setBounds(8, 10, 66, 20);
    jLDatenbank.setText("Datenbank");
    jLDatenbank.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(jLDatenbank);
    jtfDatenbank.setBounds(88, 8, 121, 24);
    jtfDatenbank.setText("Nordwind");
    jtfDatenbank.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(jtfDatenbank);
    jLSQL.setBounds(8, 40, 70, 20);
    jLSQL.setText("SQL-Befehl");
    jLSQL.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(jLSQL);
    jtaSQLAnweisungScrollPane.setBounds(8, 64, 361, 89);
    jtaSQLAnweisung.setText("SELECT * FROM Artikel");
    cp.add(jtaSQLAnweisungScrollPane);
    jBLoeschen.setBounds(376, 64, 91, 25);
    jBLoeschen.setText("Lschen");
    jBLoeschen.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBLoeschen_ActionPerformed(evt);
      }
    });
    jBLoeschen.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(jBLoeschen);
    jBSelect.setBounds(376, 96, 91, 25);
    jBSelect.setText("SELECT");
    jBSelect.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBSelect_ActionPerformed(evt);
      }
    });
    jBSelect.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(jBSelect);
    jBDMLDDL.setBounds(376, 128, 91, 25);
    jBDMLDDL.setText("DML/DDL");
    jBDMLDDL.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        jBDMLDDL_ActionPerformed(evt);
      }
    });
    jBDMLDDL.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(jBDMLDDL);
    jtaTabelleScrollPane.setBounds(8, 168, 457, 217);
    jtaTabelle.getColumnModel().getColumn(0).setHeaderValue("Title 1");
    cp.add(jtaTabelleScrollPane);
    jlDatensaetze.setBounds(8, 392, 92, 20);
    jlDatensaetze.setText("0 Datenstze");
    jlDatensaetze.setFont(new Font("Dialog", Font.PLAIN, 13));
    cp.add(jlDatensaetze);
    jtaSQLAnweisung.setFont(new Font("Dialog", Font.PLAIN, 13));
    // Ende Komponenten
    setVisible(true);
  }

  // Anfang Methoden

  public void jBLoeschen_ActionPerformed(ActionEvent evt) {
    jtaSQLAnweisung.setText("");
  }

  public void jBSelect_ActionPerformed(ActionEvent evt) {
    ResultSet SQLErgebnis;
    ResultSetMetaData SQLMetaDaten;
    Vector Attribute;
    Vector Datensaetze;

    try {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      DBVerbindung = DriverManager.getConnection("jdbc:odbc:" + jtfDatenbank.getText());
      SQLAnweisung = DBVerbindung.createStatement();
    }
    catch (Exception e) {
      String s = breche_um("Datenbank " + jtfDatenbank.getText() + " konnte nicht geffnet werden." +
                 "\n" + e.getMessage());
      JOptionPane.showMessageDialog(this, s, "Datenbank-Fehler", JOptionPane.ERROR_MESSAGE);
      return;
    }

    try {
      // Abfrage ausfhren
      String Abfrage = jtaSQLAnweisung.getText();
      SQLErgebnis = SQLAnweisung.executeQuery(Abfrage);

      // Attribute lesen
      SQLMetaDaten = SQLErgebnis.getMetaData();
      int Spalten = SQLMetaDaten.getColumnCount();
      Attribute = new Vector();
      for(int i = 0; i < Spalten; i++)
        Attribute.addElement(SQLMetaDaten.getColumnLabel(i+1));

      // Datenstze lesen
      Datensaetze = new Vector();
      while (SQLErgebnis.next()) {
        Vector neuerDatensatz = new Vector();
        for (int i = 1; i <= Spalten; i++)
          neuerDatensatz.addElement(SQLErgebnis.getObject(i));
        Datensaetze.addElement(neuerDatensatz);
      }

      // Datensaetze anzeigen
      jtaTabelle = new JTable(Datensaetze, Attribute);
      jtaTabelleScrollPane.setViewportView(jtaTabelle);
      jlDatensaetze.setText(Datensaetze.size() + " Datenstze");
      SQLErgebnis.close();
    }
    catch (SQLException e) {
      while (e != null) {
        String s = e.getMessage();
        s = breche_um(s);
        JOptionPane.showMessageDialog(this, s, "SQL-Fehler", JOptionPane.ERROR_MESSAGE);
        e = e.getNextException();
      }
    }

  }

  public void jBDMLDDL_ActionPerformed(ActionEvent evt) {
    int Datensaetze;
    String Abfrage, Antwort;

    try {
      Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      DBVerbindung = DriverManager.getConnection("jdbc:odbc:" + jtfDatenbank.getText());
      SQLAnweisung = DBVerbindung.createStatement();
    }
    catch (Exception e) {
      String s = breche_um("Datenbank " + jtfDatenbank.getText() + " konnte nicht geffnet werden." +
                 "\n" + e.getMessage());
      JOptionPane.showMessageDialog(this, s, "Datenbank-Fehler", JOptionPane.ERROR_MESSAGE);
      return;
    }

    try {
      // DML/DDL ausfhren
      Abfrage = jtaSQLAnweisung.getText();
      Datensaetze = SQLAnweisung.executeUpdate(Abfrage);

      // Ergebnis bekanntgeben
      Abfrage = Abfrage.toUpperCase();
      if (Abfrage.indexOf("INSERT") >= 0)
        Antwort = "Es wurden " + Datensaetze + " Datenstze eingefgt.";
      else if (Abfrage.indexOf("UPDATE") >= 0)
        Antwort = "Es wurden " + Datensaetze + " Datenstze aktualisiert.";
      else if (Abfrage.indexOf("DELETE") >= 0)
        Antwort = "Es wurden " + Datensaetze + " Datenstze gelscht.";
      else
        Antwort = "Die Datendefiniton wurde erfolgreich ausgefhrt.";
      JOptionPane.showMessageDialog(this, Antwort , "DML/DDL", JOptionPane.INFORMATION_MESSAGE);
    }
    catch (SQLException e) {
      while (e != null) {
        String s = e.getMessage();
        s = breche_um(s);
        JOptionPane.showMessageDialog(this, s, "SQL-Fehler", JOptionPane.ERROR_MESSAGE);
        e = e.getNextException();
      }
    }
  }

  public String breche_um(String s) {
    if (s == null) return "";
    int i = 50;
    while (i < s.length()) {
      while (i < s.length() && s.charAt(i) != ' ')
        i++;                                      // +1
      s = s.substring(0, i) + "\n" + s.substring(i, s.length());
      i = i + 50;
    }
    return s;
  }

  // Ende Methoden

  public static void main(String[] args) {
    new SQLExplorer("SQLExplorer");
  }

}
